#!/usr/bin/python
################################################################################
#	BdsDataFile1e.py	BDS API example code for a BDS DataFile access
#				T.Barnaby,	BEAM Ltd,	2012-12-19
################################################################################
#
# This Example code opens a BDRS data file, gets information from the file and then
#	reads all of the files blocks printing the first data value of each block.
# Uses exceptions.
#
import sys
import getopt
from bdslibe import *

def main():
	filename = "/autodrm/blacknest/EKA/2008/2008003_000000.EKA";
	
	try:
		dataInfo = DataInfo();
		errors = BListDataError();
		
		f = DataFileBdrs();
	
		# Open the data file
		f.open(filename, "r");
		
		# Get information from the file
		(dataInfo, errors) = f.getInfo(dataInfo, DataFile.ReadOptionValidate | DataFile.ReadOptionFileNameProcess);
		
		# Display the info
		bdsDumpDataInfo(dataInfo);
		
		# Read the data
		for b in range(0, dataInfo.channels[0][0].numBlocks):
			data = f.readData(0, 0, b);
			print "Block:", b, " Data:", data.channelData[0][0];
		

	except ExceptionBError as e:
		print "Execption", e.number, e.string;
		return 1;
		
	return 0;

if __name__ == "__main__":
	main();
