#!/usr/bin/python
################################################################################
#	BdsDataFile2.py		BDS API example code for a BDS DataFile access
#				T.Barnaby,	BEAM Ltd,	2012-12-19
################################################################################
#
# This Example code opens a Response file, gets information from the file.
#
import sys
import getopt
import cmath
from bdslib import *

def main():
	filename = "response.resp";
	errors = BListDataError();

	f = DataFileResponse();

	# Open the data file
	f.open(filename, "r");
	f.setFormat("RESPONSE");
	
	dummyChannelInfos = ChannelInfos(); 
	(err, channelInfos) = f.getMetaData(dummyChannelInfos);
	if(err):
		print "Failed to extract Ps and Zs from file ", filename, err.getString(); 

	print "Number of channels of info:", len(channelInfos.channels);
	if(len(channelInfos.channels)):
		print "Number of segments of info:", len(channelInfos.channels[0]);
		if(len(channelInfos.channels[0])):
			print "Number of Responses:", len(channelInfos.channels[0][0].responses);
			for c in range(0, len(channelInfos.channels[0][0].responses)):
				r = channelInfos.channels[0][0].responses[c];
				print "ResponseType:", r.type;
				if(r.type == "PoleZero"):
					for c in range(0, len(r.poleZeros.poles)):
						print "Pole: %f %f" % (r.poleZeros.poles[c].real, r.poleZeros.poles[c].imag);
					for c in range(0, len(r.poleZeros.zeros)):
						print "Zero: %f %f" % (r.poleZeros.zeros[c].real, r.poleZeros.zeros[c].imag);


	return 0;

if __name__ == "__main__":
	main();
