/*******************************************************************************
 *	BdsC.h	Produced by Bidl
 *******************************************************************************
 */

#ifndef BDSC_H
#define BDSC_H 1

#include <stdlib.h>
#include <stdint.h>
#include <Boap.h>
#include <BString.h>
#include <BList.h>
#include <BArray.h>
#include <BdsD.h>


//*****************************************************************************/
//	BDS API
//			T.Barnaby,	BEAM Ltd,	2008-03-04
//*****************************************************************************/
//
namespace Bds {
	const BUInt32 apiVersion = 0;

	/// This class defines a TimePeriod
	/// This class defines a Network organisation. Could have other information here like website, contacts etc
	/// This class defines a Source
	/// This class defines a Source Order entry
	/// This class defines an arrays channel
	/// This class defines a Location. This will be the stations location.
	/// This class defines a Pole/Zero Response
	/// This class defines a Amplitude/Phase Response
	/// This class defines a Pole/Zero Response
	/// This class defines a Pole/Zero Response
	/// This class defines a Response
	/// This class defines a calibration setting
	/// This class defines a Digitiser
	/// This class defines a Sensor
	/// This class defines a Channel to Digitiser/Sensor linkage
	/// This class defines a Channel
	/// This class defines the set of data selection critera
	/// This class provides information on a set of channels
	/// This class defines information on a data file
	/// This defines a handle to a data stream/file
	/// This holds information on a user
	/// This holds information on a groups
	/// This holds information on data access groups
	/// This holds information on a change
	/// This holds information on a change
	/// This holds information on a Note
	/// This holds information on a Note
	/// This is used for requesting log entries
	/// This is the clean options
	/// This holds information on a data format
	/// This class defines information on a data channel
	class DataAccess : public BoapClientObject {
	public:
			DataAccess(BString name = "");
		BError connect(BString user, BString password);	///< Provides user/password information for secure connection
		BError validateUser(BString user, BString email);	///< Checks the user given name or email
		BError setUser(BString user, BString email);	///< Sets user to given name or email
		BError setUserReal();	///< Sets user back to real user
		BError getVersion(BString& version, BString& name);	///< Gets the software version and server name
		// Information functions
		BError userGet(User& user);	/// Get user info
		BError userSet(User user);	/// Set user info
		BError userGetGroups(BList<BString >& groups);	/// Get list of groups the user belongs to
		BError groupGetList(BList<Group >& groups);	///< Get list of Groups
		BError networkGetList(BList<Network >& networks);	///< Get list of Networks
		BError stationGetList(Selection sel, BList<Station >& stations);	///< Get list of Stations
		BError channelGetList(Selection sel, BList<Channel >& channels);	///< Get list of Channels
		BError sourceGetList(BList<Source >& sources);	///< Get list of Sources
		BError sourcePriorityGetList(BList<SourcePriority >& sourcePrioritys);	///< Get list of Source	Error		sourceGetList(out List<Source> sources);				///< Get list of SourcePriorities
		BError dataFileGetList(Selection sel, BList<DataFileInfo >& dataFile);	///< Get list of DataFiles
		BError dataChannelGetList(Selection sel, BList<DataChannel >& dataChannel);	///< Get list of DataChannels
		BError channelInstrumentGetList(Selection sel, BList<ChannelInstrument >& channelInstruments);	///< Get list of Channel Instruments
		BError digitiserGetList(Selection sel, BList<Digitiser >& digitisers);	///< Get list of Channels
		BError digitiserGet(BUInt32 id, Digitiser& digitiser);
		BError sensorGetList(Selection sel, BList<Sensor >& sensors);	///< Get list of Channels
		BError sensorGet(BUInt32 id, Sensor& sensor);
		BError calibrationGetList(Selection sel, BList<Calibration >& calibrations);	///< Get list of Channels
		BError responseGetList(Selection sel, BList<Response >& responses);	///< Get list of Channels
		BError locationGetList(Selection sel, BList<Location >& locations);	///< Get list of Station Locations
		// Selections
		BError getSelectionInfo(SelectionGroup group, Selection selectionIn, SelectionInfo& selectionInfo);	///< Get selection info
		BError getSelections(SelectionGroup group, Selection selectionIn, Selection& selectionOut);	///< Get selection list
		BError dataSearch(Selection selection, DataInfo& dataInfo);	///< Search for data matching the given selection parameters
		BError dataGetChannelInfo(DataInfo dataInfo, ChannelInfos& channelInfos);	///< Return the channel MetaData in structured form
		BError dataOpen(DataInfo dataInfo, BString mode, BString format, BUInt32 flags, DataHandle& dataHandle);	///< Open a data stream
		BError dataGetInfo(DataHandle dataHandle, BUInt32 infoExtra, DataInfo& dataInfo);	///< Get information on the data stream
		BError dataGetNotes(DataHandle dataHandle, BList<Note >& notes);	///< Get notes on the data stream
		BError dataGetWarnings(DataHandle dataHandle, BList<BString >& warnings);	///< Get information on the data stream
		BError dataSeekBlock(DataHandle dataHandle, BUInt32 channel, BUInt32 segment, BTimeStamp time, BUInt32& blockNumber);	///< Searches for a data block matching the time given
		BError dataGetBlock(DataHandle dataHandle, BUInt32 channel, BUInt32 segment, BUInt32 blockNumber, DataBlock& data);	///< Return a block of data
		BError dataClose(DataHandle dataHandle, BError error, BInt32 del);	///< Close a stream
		BError dataFormattedRead(DataHandle dataHandle, BUInt32 number, BArray<BUInt8 >& data);	///< Read the raw data from the stream
		BError dataFormattedGetLength(DataHandle dataHandle, BUInt64& length);	///< Read the raw data from the stream
		BError noteGetList(Selection sel, BList<Note >& notes);
		BError noteUpdate(BInt32 append, Note note, BUInt32& id);
		BError noteWriteDocument(BUInt32 id, BString format, BArray<BUInt8 > data);
		BError noteReadDocument(BUInt32 id, BString& format, BArray<BUInt8 >& data);
		BError logUpdate(BInt32 append, Log log, BUInt32& id);	///< Append a log item
		BError logAppend(BString type, BUInt32 priority, BString subSystem, BString title, BString description);	///< Append a log item
		// Management functions
		BError modeSet(Mode mode, Mode& previousMode);	///< Changes the system mode from Master to slave
		BError modeSnapshotPause(BInt32 on);	///< Enables/disables backup synchronisation pause
		BError clean(CleanOptions cleanOptions);	///< Cleans the system logs and Changes information
		BError databaseBackup(BString& ref);	///< Backup the database
		// Information functions
		BError statisticsGet(BDict<BString >& info);
		BError dataFormatGetList(BList<DataFormat >& formats);	///< Get list of data formats
	private:
	};
	//
	/// This is the DataAdd Access API interface
	class DataAddAccess : public BoapClientObject {
	public:
			DataAddAccess(BString name = "");
		BError connect(BString user, BString password);	///< Provides user/password information
		BError validateUser(BString user, BString email);	///< Checks the user given name or email
		BError setUser(BString user, BString email);	///< Sets user to given name or email
		BError setUserReal();	///< Sets user back to real user
		BError getVersion(BString& version, BString& name);	///< Gets the software version and server name
		// Information functions
		BError userGet(User& user);	/// Get user info
		BError userSet(User user);	/// Set user info
		BError userGetGroups(BList<BString >& groups);	/// Get list of groups the user belongs to
		BError groupGetList(BList<Group >& groups);	///< Get list of Groups
		BError networkGetList(BList<Network >& networks);	///< Get list of Networks
		BError stationGetList(Selection sel, BList<Station >& stations);	///< Get list of Stations
		BError channelGetList(Selection sel, BList<Channel >& channels);	///< Get list of Channels
		BError sourceGetList(BList<Source >& sources);	///< Get list of Sources
		BError sourcePriorityGetList(BList<SourcePriority >& sourcePrioritys);	///< Get list of Source	Error		sourceGetList(out List<Source> sources);				///< Get list of SourcePriorities
		BError dataFileGetList(Selection sel, BList<DataFileInfo >& dataFile);	///< Get list of DataFiles
		BError dataChannelGetList(Selection sel, BList<DataChannel >& dataChannel);	///< Get list of DataChannels
		BError channelInstrumentGetList(Selection sel, BList<ChannelInstrument >& channelInstruments);	///< Get list of Channel Instruments
		BError digitiserGetList(Selection sel, BList<Digitiser >& digitisers);	///< Get list of Channels
		BError digitiserGet(BUInt32 id, Digitiser& digitiser);
		BError sensorGetList(Selection sel, BList<Sensor >& sensors);	///< Get list of Channels
		BError sensorGet(BUInt32 id, Sensor& sensor);
		BError calibrationGetList(Selection sel, BList<Calibration >& calibrations);	///< Get list of Channels
		BError responseGetList(Selection sel, BList<Response >& responses);	///< Get list of Channels
		BError locationGetList(Selection sel, BList<Location >& locations);	///< Get list of Station Locations
		// Selections
		BError getSelectionInfo(SelectionGroup group, Selection selectionIn, SelectionInfo& selectionInfo);	///< Get selection info
		BError getSelections(SelectionGroup group, Selection selectionIn, Selection& selectionOut);	///< Get selection list
		BError dataSearch(Selection selection, DataInfo& dataInfo);	///< Search for data matching the given selection parameters
		BError dataGetChannelInfo(DataInfo dataInfo, ChannelInfos& channelInfos);	///< Return the channel MetaData in structured form
		BError dataOpen(DataInfo dataInfo, BString mode, BString format, BUInt32 flags, DataHandle& dataHandle);	///< Open a data stream
		BError dataGetInfo(DataHandle dataHandle, BUInt32 infoExtra, DataInfo& dataInfo);	///< Get information on the data stream
		BError dataGetNotes(DataHandle dataHandle, BList<Note >& notes);	///< Get notes on the data stream
		BError dataGetWarnings(DataHandle dataHandle, BList<BString >& warnings);	///< Get information on the data stream
		BError dataSeekBlock(DataHandle dataHandle, BUInt32 channel, BUInt32 segment, BTimeStamp time, BUInt32& blockNumber);	///< Searches for a data block matching the time given
		BError dataGetBlock(DataHandle dataHandle, BUInt32 channel, BUInt32 segment, BUInt32 blockNumber, DataBlock& data);	///< Return a block of data
		BError dataSetInfo(DataHandle dataHandle, DataInfo dataInfo);	///< Set the info when writing to a stream
		BError dataPutBlock(DataHandle dataHandle, DataBlock data);	///< Send a block of data
		BError dataClose(DataHandle dataHandle, BError error, BInt32 del);	///< Close a stream
		BError dataFormattedRead(DataHandle dataHandle, BUInt32 number, BArray<BUInt8 >& data);	///< Read the raw data from the stream
		BError dataFormattedGetLength(DataHandle dataHandle, BUInt64& length);	///< The total length in bytes of the formated data.
		BError noteGetList(Selection sel, BList<Note >& notes);
		BError noteUpdate(BInt32 append, Note note, BUInt32& id);
		BError noteWriteDocument(BUInt32 id, BString format, BArray<BUInt8 > data);
		BError noteReadDocument(BUInt32 id, BString& format, BArray<BUInt8 >& data);
		BError logUpdate(BInt32 append, Log log, BUInt32& id);	///< Append a log item
		BError logAppend(BString type, BUInt32 priority, BString subSystem, BString title, BString description);	///< Append a log item
		// Management functions
		BError modeSet(Mode mode, Mode& previousMode);	///< Changes the system mode from Master to slave
		BError modeSnapshotPause(BInt32 on);	///< Enables/disables backup synchronisation pause
		BError clean(CleanOptions cleanOptions);	///< Cleans the system logs and Changes information
		BError databaseBackup(BString& ref);	///< Backup the database
		// Information functions
		BError statisticsGet(BDict<BString >& info);
		BError dataFormatGetList(BList<DataFormat >& formats);	///< Get list of data formats
	private:
	};
	//
	/// This is the AdminAccess API interface
	class AdminAccess : public BoapClientObject {
	public:
			AdminAccess(BString name = "");
		BError connect(BString user, BString password);	///< Provides user/password information
		BError validateUser(BString user, BString email);	///< Checks the user given name or email
		BError setUser(BString user, BString email);	///< Sets user to given name or email
		BError setUserReal();	///< Sets user back to real user
		BError getVersion(BString& version, BString& name);	///< Gets the software version and server name
		// User functions
		BError userGetList(BList<User >& users);	///< Get list of Users
		BError userUpdate(BInt32 append, User user, BUInt32& id);	///< Update or append a user entry
		BError userDelete(BUInt32 id);	///< Delete a user entry
		BError userGet(User& user);	/// Get user info
		BError userSet(User user);	/// Set user info
		BError userGetGroups(BList<BString >& groups);	/// Get list of groups the user belongs to
		BError groupGetList(BList<Group >& groups);	///< Get list of Groups
		BError groupUpdate(BInt32 append, Group group, BUInt32& id);	///< Update or append a group entry
		BError groupDelete(BUInt32 id);	///< Delete a group entry
		BError accessGroupGetList(BList<AccessGroup >& accessGroups);	///< Get list of AccessGroups
		BError accessGroupUpdate(BInt32 append, AccessGroup group, BUInt32& id);	///< Update or append an AccessGroup entry
		BError accessGroupDelete(BUInt32 id);	///< Delete an AccessGroup entry
		// Selections
		BError getSelectionInfo(SelectionGroup group, Selection selectionIn, SelectionInfo& selectionInfo);	///< Get selection info
		BError getSelections(SelectionGroup group, Selection selectionIn, Selection& selectionOut);	///< Get selection list
		BError networkGetList(BList<Network >& networks);	///< Get list of Networks
		BError networkUpdate(BInt32 append, Network network, BUInt32& id);
		BError networkDelete(BUInt32 id);
		BError stationGetList(Selection sel, BList<Station >& stations);	///< Get list of Stations
		BError stationUpdate(BInt32 append, Station station, BUInt32& id);
		BError stationDelete(BUInt32 id);
		BError locationGetList(Selection sel, BList<Location >& locations);	///< Get list of Station Locations
		BError locationUpdate(BInt32 append, Location location, BUInt32& id);
		BError locationDelete(BUInt32 id);
		BError channelGetList(Selection sel, BList<Channel >& channels);	///< Get list of Channels
		BError channelGet(BUInt32 id, Channel& channel);	///< Get a channel
		BError channelUpdate(BInt32 append, Channel channel, BUInt32& id);
		BError channelDelete(BUInt32 id);
		BError sourceGetList(BList<Source >& sources);	///< Get list of Sources
		BError sourceUpdate(BInt32 append, Source source, BUInt32& id);
		BError sourceDelete(BUInt32 id);
		BError sourcePriorityGetList(BList<SourcePriority >& sourcePrioritys);	///< Get list of Source	Error		sourceGetList(out List<Source> sources);				///< Get list of SourcePriorities
		BError sourcePriorityUpdate(BInt32 append, SourcePriority sourcePriority, BUInt32& id);
		BError sourcePriorityDelete(BUInt32 id);
		BError channelInstrumentGetList(Selection sel, BList<ChannelInstrument >& channelInstruments);	///< Get list of Channel Instruments
		BError channelInstrumentUpdate(BInt32 append, ChannelInstrument channelInstrument, BUInt32& id);
		BError channelInstrumentDelete(BUInt32 id);
		BError digitiserGetList(Selection sel, BList<Digitiser >& digitisers);	///< Get list of Channels
		BError digitiserGet(BUInt32 id, Digitiser& digitiser);
		BError digitiserUpdate(BInt32 append, Digitiser digitiser, BUInt32& id);
		BError digitiserDelete(BUInt32 id);
		BError sensorGetList(Selection sel, BList<Sensor >& sensors);	///< Get list of Channels
		BError sensorGet(BUInt32 id, Sensor& sensor);
		BError sensorUpdate(BInt32 append, Sensor sensor, BUInt32& id);
		BError sensorDelete(BUInt32 id);
		BError calibrationGetList(Selection sel, BList<Calibration >& calibrations);	///< Get list of Channels
		BError calibrationUpdate(BInt32 append, Calibration calibration, BUInt32& id);
		BError calibrationDelete(BUInt32 id);
		BError responseGetList(Selection sel, BList<Response >& responses);	///< Get list of Channels
		BError responseUpdate(BInt32 append, Response response, BUInt32& id);
		BError responseDelete(BUInt32 id);
		BError dataFileGetList(Selection sel, BList<DataFileInfo >& dataFile);	///< Get list of DataFiles
		BError dataFileUpdate(BInt32 append, DataFileInfo dataFile, BUInt32& id);
		BError dataFileDelete(BUInt32 id);
		BError dataChannelGetList(Selection sel, BList<DataChannel >& dataChannel);	///< Get list of DataChannels
		BError dataChannelUpdate(BInt32 append, DataChannel dataChannel, BUInt32& id);
		BError dataChannelDelete(BUInt32 id);
		BError dataSearch(Selection selection, DataInfo& dataInfo);	///< Search for data matching the given selection parameters
		BError dataGetChannelInfo(DataInfo dataInfo, ChannelInfos& channelInfos);	///< Return the channel MetaData in structured form
		BError dataOpen(DataInfo dataInfo, BString mode, BString format, BUInt32 flags, DataHandle& dataHandle);	///< Open a data stream
		BError dataGetInfo(DataHandle dataHandle, BUInt32 infoExtra, DataInfo& dataInfo);	///< Get information on the data stream
		BError dataGetNotes(DataHandle dataHandle, BList<Note >& notes);	///< Get notes on the data stream
		BError dataGetWarnings(DataHandle dataHandle, BList<BString >& warnings);	///< Get information on the data stream
		BError dataGetBlock(DataHandle dataHandle, BUInt32 channel, BUInt32 segment, BUInt32 blockNumber, DataBlock& data);	///< Return a block of data
		BError dataSeekBlock(DataHandle dataHandle, BUInt32 channel, BUInt32 segment, BTimeStamp time, BUInt32& blockNumber);	///< Searches for a data block matching the time given
		BError dataSetInfo(DataHandle dataHandle, DataInfo dataInfo);	///< Set the info when writing to a stream
		BError dataPutBlock(DataHandle dataHandle, DataBlock data);	///< Send a block of data
		BError dataClose(DataHandle dataHandle, BError error, BInt32 del);	///< Close a stream
		BError dataFormattedRead(DataHandle dataHandle, BUInt32 number, BArray<BUInt8 >& data);	///< Read the raw data from the stream
		BError dataFormattedGetLength(DataHandle dataHandle, BUInt64& length);	///< Read the raw data from the stream
		// Change/Logging functions
		BError changeGroupStart(ChangeGroup changeGroup);
		BError changeGroupEnd();
		BError changeGroupGetList(ListRange range, BList<ChangeGroup >& changeGroups);
		BError changeGroupDelete(BTimeStamp beforeDate, BString type, BInt32 empty);
		BError changeGetListNumber(BUInt32 id, BUInt32& number);
		BError changeGetList(BUInt32 id, ListRange range, BList<Change >& changes);
		BError changeDelete(BTimeStamp beforeDate, BString type);
		BError noteGetList(Selection sel, BList<Note >& notes);
		BError noteUpdate(BInt32 append, Note note, BUInt32& id);
		BError noteDelete(BUInt32 id);
		BError noteWriteDocument(BUInt32 id, BString format, BArray<BUInt8 > data);
		BError noteReadDocument(BUInt32 id, BString& format, BArray<BUInt8 >& data);
		BError logGetList(LogSelect sel, BList<Log >& logs);	///< Get list of log entries
		BError logUpdate(BInt32 append, Log log, BUInt32& id);	///< Append a log item
		BError logDelete(BUInt32 id);
		BError logAppend(BString type, BUInt32 priority, BString subSystem, BString title, BString description);	///< Append a log item
		// Information functions
		BError statisticsGet(BDict<BString >& info);
		BError dataFormatGetList(BList<DataFormat >& formats);	///< Get list of data formats
		// Management functions
		BError transactionStart();	///< Starts a set of transactions
		BError transactionEnd(BInt32 abort);	///< Ends a set of transactions
		BError modeSet(Mode mode, Mode& previousMode);	///< Changes the system mode from Master to slave
		BError modeSnapshotPause(BInt32 on);	///< Enables/disables backup synchronisation pause
		BError clean(CleanOptions cleanOptions);	///< Cleans the system logs and Changes information
		BError databaseBackup(BString& ref);	///< Backup the database
		BError databaseRestore(BString ref, BString type);	///< Restore the database
		// Low level functions
		BError sqlQuery(BString query, BList<BDict<BString > >& result);	///< A low level SQL access function
	private:
	};
	//
}
#endif
