/*******************************************************************************
 *	BdsCompress.h	Data Compression Functions
 *			T.Barnaby,	BEAM Ltd,	2009-05-15
 *******************************************************************************
 */
#ifndef BdsCompress_H
#define	BdsCompress_H

#include <BError.h>
#include <BArray.h>

namespace Bds {

BError	bdsUnCompressCm8(BUInt8* buffer, BUInt n, BArray<BInt32>& data);
BError	bdsUnCompressSteim1(BUInt8* buffer, BUInt n, BArray<BInt32>& data);


class CompressSteim1 {
public:
		CompressSteim1();
	void	setByteOrder(int swap);
	void	clear();
	
	BError	unCompress(void* buffer, BUInt numSamples, BArray<BInt32>& data);
private:
	int	oswapBytes;
};

}
#endif
