/*******************************************************************************
 *	BdsDataFileGcf.h	BDRS Data File Access
 *			T.Barnaby,	BEAM Ltd,	2008-06-24
 *******************************************************************************
 */
#ifndef BdsDataFileGcf_H
#define	BdsDataFileGcf_H

#include <BdsDataFile.h>

namespace Bds {

struct GcfChannel {
	BString		systemId;
	BString		streamId;
	BUInt		type;
	BUInt		sampleRate;
	BUInt		format;
	BUInt32		channel;
};

class DataFileGcf : public DataFile{
public:
				DataFileGcf();

	int			getFeatures();						///< Get bitmask of supported features
	DataOrder		getDataOrder();

	BError			getInfo(DataInfo& dataInfo, DataFileOptions options, BList<DataError>& errors);
	BError			readData(BUInt32 channel, BUInt segment, BUInt32 blockNumber, DataBlock& data);

	static DataFormat	getFormats();
private:
	BError			readBlock(BUInt32 channel, BUInt64 pos, DataBlock& data, int addInfo, BUInt& dataChan);
	DataError		getBlockReorderInfo();					///< Returns information on any block re-ordering performed

	BUInt32			oblockSize;
	DataFileOptions		ooptions;
	DataInfo		odataInfo;
	BArray<GcfChannel>	ochannels;			///< The channels
	BArray<BArray<DataBlockPos> >	oblockPositions;	///< The block positions per channel
};

}
#endif
