/*******************************************************************************
 *	BdsDataFileIms.h	Data File Access
 *			T.Barnaby,	BEAM Ltd,	2008-08-08
 *******************************************************************************
 */
#ifndef BdsDataFileIms_H
#define	BdsDataFileIms_H

#include <BdsDataFile.h>
#include <BdsD.h>

namespace Bds {

class DataFileIms : public DataFile {
public:
				DataFileIms();

	BError			open(BString fileName, BString mode);
	BError			close();

	DataOrder		getDataOrder();
	int			getFeatures();

	BError			setInfo(DataInfo& dataInfo, ChannelInfos& channelInfos, WriteOptionsList options = WriteOptionNone);
	BError			start(BUInt channel, BUInt segment);
	BError			writeData(DataBlock& data);
	BError			end();	

	BError			getMetaData(ChannelInfos& channelInfos);

	static DataFormat	getFormats();
private:
	BError			writeResponses();
	BError			writeResponse(ChannelInfo& ci, Response& r);

	DataInfo		odataInfo;
	ChannelInfos		ochannelInfos;
	BUInt			owriteChannel;
	BInt32			owriteChecksum;
	BUInt			owriteColumn;
	
	BInt32			oprevValue1;
	BInt32			oprevValue2;
};

}
#endif
