/*******************************************************************************
 *	BdsDataFileWra.h	BDRS Data File Access
 *			T.Barnaby,	BEAM Ltd,	2009-05-11
 *******************************************************************************
 */
#ifndef BdsDataFileWra_H
#define	BdsDataFileWra_H

#include <BdsDataFile.h>

namespace Bds {

class DataFileWra : public DataFile{
public:
				DataFileWra();

	BError			setFormat(BString format);
	int			getFeatures();						///< Get bitmask of supported features
	DataOrder		getDataOrder();

	BError			getInfo(DataInfo& dataInfo, DataFileOptions options, BList<DataError>& errors);
	BError			readData(BUInt32 channel, BUInt segment, BUInt32 blockNumber, DataBlock& data);

	static DataFormat	getFormats();
private:
	BError			readBlock(BUInt32 channel, BUInt64 pos, DataBlock& data);

	int			omagic;
	int			oyear;
	int			oblockYear;
	BUInt32			oblockSize;
	BUInt32			onumChannels;
	double			osampleRate;
	DataInfo		odataInfo;
	BArray<BUInt64>		oblockPositions;
};

}
#endif
