/*******************************************************************************
 *	BdsDataFileWraAgso.h	BDRS Data File Access
 *			T.Barnaby,	BEAM Ltd,	2009-05-11
 *******************************************************************************
 */
#ifndef BdsDataFileWraAgso_H
#define	BdsDataFileWraAgso_H

#include <BdsDataFile.h>

namespace Bds {

class DataFileWraAgso : public DataFile{
public:
				DataFileWraAgso();

	int			getFeatures();						///< Get bitmask of supported features
	DataOrder		getDataOrder();

	BError			getInfo(DataInfo& dataInfo, DataFileOptions options, BList<DataError>& errors);
	BError			readData(BUInt32 channel, BUInt segment, BUInt32 blockNumber, DataBlock& data);

	static DataFormat	getFormats();
private:
	BError			readBlock(BUInt32 blockNumber, BString& channelheader, DataBlock& data);
	int			oyear;
	int			oblockYear;
	BUInt32			oblockSize;
	double			osampleRate;
	DataInfo		odataInfo;
	BArray<BUInt>		ochannelStartBlocks;
	BUInt			oreadChannel;
	BUInt			oreadBlock;
	BUInt			ocurrentBlock;
	static int		ofieldWidths[];
};

}
#endif
