/*******************************************************************************
 *	BdsDataLib.h	Data File Access
 *			T.Barnaby,	BEAM Ltd,	2008-11-20
 *******************************************************************************
 */
#ifndef BdsDataLib_H
#define	BdsDataLib_H

#include <BdsDataFile.h>

namespace Bds {

BString fixedWidthValue(double v, int width);

/// This class defines the interface for generic data file access
class DataFormats {
public:
				DataFormats();
				~DataFormats();
				
	BError		formatList(BList<DataFormat>& formats);
	BError		formatGet(BString format, DataFile*& dataFile);
	
protected:
	int		findFormat(DataFormat dataFormat, BString string);
};

extern DataFormats	dataFormats;

}
#endif
