/*******************************************************************************
 *	BdsS.h	Produced by Bidl
 *******************************************************************************
 */

#ifndef BDSS_H
#define BDSS_H 1

#include <stdint.h>
#include <Boap.h>
#include <BString.h>

#include <BdsC.h>

class Connection;

namespace Bds {
	class DataAccessService : public BoapServiceObject {
	public:
			DataAccessService(BoapServer& server, BString name);
		BError doconnect(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError connect(Connection* conn, BString user, BString password) = 0;
		BError dovalidateUser(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError validateUser(Connection* conn, BString user, BString email) = 0;
		BError dosetUser(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError setUser(Connection* conn, BString user, BString email) = 0;
		BError dosetUserReal(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError setUserReal(Connection* conn) = 0;
		BError dogetVersion(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError getVersion(Connection* conn, BString& version, BString& name) = 0;
		BError douserGet(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError userGet(Connection* conn, User& user) = 0;
		BError douserSet(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError userSet(Connection* conn, User user) = 0;
		BError douserGetGroups(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError userGetGroups(Connection* conn, BList<BString >& groups) = 0;
		BError dogroupGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError groupGetList(Connection* conn, BList<Group >& groups) = 0;
		BError donetworkGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError networkGetList(Connection* conn, BList<Network >& networks) = 0;
		BError dostationGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError stationGetList(Connection* conn, Selection sel, BList<Station >& stations) = 0;
		BError dochannelGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError channelGetList(Connection* conn, Selection sel, BList<Channel >& channels) = 0;
		BError dosourceGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError sourceGetList(Connection* conn, BList<Source >& sources) = 0;
		BError dosourcePriorityGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError sourcePriorityGetList(Connection* conn, BList<SourcePriority >& sourcePrioritys) = 0;
		BError dodataFileGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataFileGetList(Connection* conn, Selection sel, BList<DataFileInfo >& dataFile) = 0;
		BError dodataChannelGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataChannelGetList(Connection* conn, Selection sel, BList<DataChannel >& dataChannel) = 0;
		BError dochannelInstrumentGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError channelInstrumentGetList(Connection* conn, Selection sel, BList<ChannelInstrument >& channelInstruments) = 0;
		BError dodigitiserGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError digitiserGetList(Connection* conn, Selection sel, BList<Digitiser >& digitisers) = 0;
		BError dodigitiserGet(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError digitiserGet(Connection* conn, BUInt32 id, Digitiser& digitiser) = 0;
		BError dosensorGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError sensorGetList(Connection* conn, Selection sel, BList<Sensor >& sensors) = 0;
		BError dosensorGet(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError sensorGet(Connection* conn, BUInt32 id, Sensor& sensor) = 0;
		BError docalibrationGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError calibrationGetList(Connection* conn, Selection sel, BList<Calibration >& calibrations) = 0;
		BError doresponseGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError responseGetList(Connection* conn, Selection sel, BList<Response >& responses) = 0;
		BError dolocationGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError locationGetList(Connection* conn, Selection sel, BList<Location >& locations) = 0;
		BError dogetSelectionInfo(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError getSelectionInfo(Connection* conn, SelectionGroup group, Selection selectionIn, SelectionInfo& selectionInfo) = 0;
		BError dogetSelections(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError getSelections(Connection* conn, SelectionGroup group, Selection selectionIn, Selection& selectionOut) = 0;
		BError dodataSearch(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataSearch(Connection* conn, Selection selection, DataInfo& dataInfo) = 0;
		BError dodataGetChannelInfo(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataGetChannelInfo(Connection* conn, DataInfo dataInfo, ChannelInfos& channelInfos) = 0;
		BError dodataOpen(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataOpen(Connection* conn, DataInfo dataInfo, BString mode, BString format, BUInt32 flags, DataHandle& dataHandle) = 0;
		BError dodataGetInfo(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataGetInfo(Connection* conn, DataHandle dataHandle, BUInt32 infoExtra, DataInfo& dataInfo) = 0;
		BError dodataGetNotes(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataGetNotes(Connection* conn, DataHandle dataHandle, BList<Note >& notes) = 0;
		BError dodataGetWarnings(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataGetWarnings(Connection* conn, DataHandle dataHandle, BList<BString >& warnings) = 0;
		BError dodataSeekBlock(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataSeekBlock(Connection* conn, DataHandle dataHandle, BUInt32 channel, BUInt32 segment, BTimeStamp time, BUInt32& blockNumber) = 0;
		BError dodataGetBlock(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataGetBlock(Connection* conn, DataHandle dataHandle, BUInt32 channel, BUInt32 segment, BUInt32 blockNumber, DataBlock& data) = 0;
		BError dodataClose(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataClose(Connection* conn, DataHandle dataHandle, BError error, BInt32 del) = 0;
		BError dodataFormattedRead(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataFormattedRead(Connection* conn, DataHandle dataHandle, BUInt32 number, BArray<BUInt8 >& data) = 0;
		BError dodataFormattedGetLength(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataFormattedGetLength(Connection* conn, DataHandle dataHandle, BUInt64& length) = 0;
		BError donoteGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError noteGetList(Connection* conn, Selection sel, BList<Note >& notes) = 0;
		BError donoteUpdate(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError noteUpdate(Connection* conn, BInt32 append, Note note, BUInt32& id) = 0;
		BError donoteWriteDocument(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError noteWriteDocument(Connection* conn, BUInt32 id, BString format, BArray<BUInt8 > data) = 0;
		BError donoteReadDocument(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError noteReadDocument(Connection* conn, BUInt32 id, BString& format, BArray<BUInt8 >& data) = 0;
		BError dologUpdate(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError logUpdate(Connection* conn, BInt32 append, Log log, BUInt32& id) = 0;
		BError dologAppend(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError logAppend(Connection* conn, BString type, BUInt32 priority, BString subSystem, BString title, BString description) = 0;
		BError domodeSet(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError modeSet(Connection* conn, Mode mode, Mode& previousMode) = 0;
		BError domodeSnapshotPause(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError modeSnapshotPause(Connection* conn, BInt32 on) = 0;
		BError doclean(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError clean(Connection* conn, CleanOptions cleanOptions) = 0;
		BError dodatabaseBackup(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError databaseBackup(Connection* conn, BString& ref) = 0;
		BError dostatisticsGet(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError statisticsGet(Connection* conn, BDict<BString >& info) = 0;
		BError dodataFormatGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataFormatGetList(Connection* conn, BList<DataFormat >& formats) = 0;
	};
	class DataAddAccessService : public BoapServiceObject {
	public:
			DataAddAccessService(BoapServer& server, BString name);
		BError doconnect(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError connect(Connection* conn, BString user, BString password) = 0;
		BError dovalidateUser(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError validateUser(Connection* conn, BString user, BString email) = 0;
		BError dosetUser(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError setUser(Connection* conn, BString user, BString email) = 0;
		BError dosetUserReal(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError setUserReal(Connection* conn) = 0;
		BError dogetVersion(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError getVersion(Connection* conn, BString& version, BString& name) = 0;
		BError douserGet(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError userGet(Connection* conn, User& user) = 0;
		BError douserSet(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError userSet(Connection* conn, User user) = 0;
		BError douserGetGroups(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError userGetGroups(Connection* conn, BList<BString >& groups) = 0;
		BError dogroupGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError groupGetList(Connection* conn, BList<Group >& groups) = 0;
		BError donetworkGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError networkGetList(Connection* conn, BList<Network >& networks) = 0;
		BError dostationGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError stationGetList(Connection* conn, Selection sel, BList<Station >& stations) = 0;
		BError dochannelGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError channelGetList(Connection* conn, Selection sel, BList<Channel >& channels) = 0;
		BError dosourceGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError sourceGetList(Connection* conn, BList<Source >& sources) = 0;
		BError dosourcePriorityGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError sourcePriorityGetList(Connection* conn, BList<SourcePriority >& sourcePrioritys) = 0;
		BError dodataFileGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataFileGetList(Connection* conn, Selection sel, BList<DataFileInfo >& dataFile) = 0;
		BError dodataChannelGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataChannelGetList(Connection* conn, Selection sel, BList<DataChannel >& dataChannel) = 0;
		BError dochannelInstrumentGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError channelInstrumentGetList(Connection* conn, Selection sel, BList<ChannelInstrument >& channelInstruments) = 0;
		BError dodigitiserGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError digitiserGetList(Connection* conn, Selection sel, BList<Digitiser >& digitisers) = 0;
		BError dodigitiserGet(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError digitiserGet(Connection* conn, BUInt32 id, Digitiser& digitiser) = 0;
		BError dosensorGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError sensorGetList(Connection* conn, Selection sel, BList<Sensor >& sensors) = 0;
		BError dosensorGet(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError sensorGet(Connection* conn, BUInt32 id, Sensor& sensor) = 0;
		BError docalibrationGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError calibrationGetList(Connection* conn, Selection sel, BList<Calibration >& calibrations) = 0;
		BError doresponseGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError responseGetList(Connection* conn, Selection sel, BList<Response >& responses) = 0;
		BError dolocationGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError locationGetList(Connection* conn, Selection sel, BList<Location >& locations) = 0;
		BError dogetSelectionInfo(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError getSelectionInfo(Connection* conn, SelectionGroup group, Selection selectionIn, SelectionInfo& selectionInfo) = 0;
		BError dogetSelections(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError getSelections(Connection* conn, SelectionGroup group, Selection selectionIn, Selection& selectionOut) = 0;
		BError dodataSearch(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataSearch(Connection* conn, Selection selection, DataInfo& dataInfo) = 0;
		BError dodataGetChannelInfo(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataGetChannelInfo(Connection* conn, DataInfo dataInfo, ChannelInfos& channelInfos) = 0;
		BError dodataOpen(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataOpen(Connection* conn, DataInfo dataInfo, BString mode, BString format, BUInt32 flags, DataHandle& dataHandle) = 0;
		BError dodataGetInfo(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataGetInfo(Connection* conn, DataHandle dataHandle, BUInt32 infoExtra, DataInfo& dataInfo) = 0;
		BError dodataGetNotes(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataGetNotes(Connection* conn, DataHandle dataHandle, BList<Note >& notes) = 0;
		BError dodataGetWarnings(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataGetWarnings(Connection* conn, DataHandle dataHandle, BList<BString >& warnings) = 0;
		BError dodataSeekBlock(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataSeekBlock(Connection* conn, DataHandle dataHandle, BUInt32 channel, BUInt32 segment, BTimeStamp time, BUInt32& blockNumber) = 0;
		BError dodataGetBlock(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataGetBlock(Connection* conn, DataHandle dataHandle, BUInt32 channel, BUInt32 segment, BUInt32 blockNumber, DataBlock& data) = 0;
		BError dodataSetInfo(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataSetInfo(Connection* conn, DataHandle dataHandle, DataInfo dataInfo) = 0;
		BError dodataPutBlock(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataPutBlock(Connection* conn, DataHandle dataHandle, DataBlock data) = 0;
		BError dodataClose(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataClose(Connection* conn, DataHandle dataHandle, BError error, BInt32 del) = 0;
		BError dodataFormattedRead(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataFormattedRead(Connection* conn, DataHandle dataHandle, BUInt32 number, BArray<BUInt8 >& data) = 0;
		BError dodataFormattedGetLength(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataFormattedGetLength(Connection* conn, DataHandle dataHandle, BUInt64& length) = 0;
		BError donoteGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError noteGetList(Connection* conn, Selection sel, BList<Note >& notes) = 0;
		BError donoteUpdate(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError noteUpdate(Connection* conn, BInt32 append, Note note, BUInt32& id) = 0;
		BError donoteWriteDocument(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError noteWriteDocument(Connection* conn, BUInt32 id, BString format, BArray<BUInt8 > data) = 0;
		BError donoteReadDocument(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError noteReadDocument(Connection* conn, BUInt32 id, BString& format, BArray<BUInt8 >& data) = 0;
		BError dologUpdate(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError logUpdate(Connection* conn, BInt32 append, Log log, BUInt32& id) = 0;
		BError dologAppend(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError logAppend(Connection* conn, BString type, BUInt32 priority, BString subSystem, BString title, BString description) = 0;
		BError domodeSet(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError modeSet(Connection* conn, Mode mode, Mode& previousMode) = 0;
		BError domodeSnapshotPause(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError modeSnapshotPause(Connection* conn, BInt32 on) = 0;
		BError doclean(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError clean(Connection* conn, CleanOptions cleanOptions) = 0;
		BError dodatabaseBackup(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError databaseBackup(Connection* conn, BString& ref) = 0;
		BError dostatisticsGet(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError statisticsGet(Connection* conn, BDict<BString >& info) = 0;
		BError dodataFormatGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataFormatGetList(Connection* conn, BList<DataFormat >& formats) = 0;
	};
	class AdminAccessService : public BoapServiceObject {
	public:
			AdminAccessService(BoapServer& server, BString name);
		BError doconnect(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError connect(Connection* conn, BString user, BString password) = 0;
		BError dovalidateUser(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError validateUser(Connection* conn, BString user, BString email) = 0;
		BError dosetUser(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError setUser(Connection* conn, BString user, BString email) = 0;
		BError dosetUserReal(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError setUserReal(Connection* conn) = 0;
		BError dogetVersion(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError getVersion(Connection* conn, BString& version, BString& name) = 0;
		BError douserGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError userGetList(Connection* conn, BList<User >& users) = 0;
		BError douserUpdate(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError userUpdate(Connection* conn, BInt32 append, User user, BUInt32& id) = 0;
		BError douserDelete(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError userDelete(Connection* conn, BUInt32 id) = 0;
		BError douserGet(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError userGet(Connection* conn, User& user) = 0;
		BError douserSet(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError userSet(Connection* conn, User user) = 0;
		BError douserGetGroups(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError userGetGroups(Connection* conn, BList<BString >& groups) = 0;
		BError dogroupGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError groupGetList(Connection* conn, BList<Group >& groups) = 0;
		BError dogroupUpdate(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError groupUpdate(Connection* conn, BInt32 append, Group group, BUInt32& id) = 0;
		BError dogroupDelete(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError groupDelete(Connection* conn, BUInt32 id) = 0;
		BError doaccessGroupGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError accessGroupGetList(Connection* conn, BList<AccessGroup >& accessGroups) = 0;
		BError doaccessGroupUpdate(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError accessGroupUpdate(Connection* conn, BInt32 append, AccessGroup group, BUInt32& id) = 0;
		BError doaccessGroupDelete(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError accessGroupDelete(Connection* conn, BUInt32 id) = 0;
		BError dogetSelectionInfo(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError getSelectionInfo(Connection* conn, SelectionGroup group, Selection selectionIn, SelectionInfo& selectionInfo) = 0;
		BError dogetSelections(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError getSelections(Connection* conn, SelectionGroup group, Selection selectionIn, Selection& selectionOut) = 0;
		BError donetworkGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError networkGetList(Connection* conn, BList<Network >& networks) = 0;
		BError donetworkUpdate(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError networkUpdate(Connection* conn, BInt32 append, Network network, BUInt32& id) = 0;
		BError donetworkDelete(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError networkDelete(Connection* conn, BUInt32 id) = 0;
		BError dostationGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError stationGetList(Connection* conn, Selection sel, BList<Station >& stations) = 0;
		BError dostationUpdate(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError stationUpdate(Connection* conn, BInt32 append, Station station, BUInt32& id) = 0;
		BError dostationDelete(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError stationDelete(Connection* conn, BUInt32 id) = 0;
		BError dolocationGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError locationGetList(Connection* conn, Selection sel, BList<Location >& locations) = 0;
		BError dolocationUpdate(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError locationUpdate(Connection* conn, BInt32 append, Location location, BUInt32& id) = 0;
		BError dolocationDelete(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError locationDelete(Connection* conn, BUInt32 id) = 0;
		BError dochannelGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError channelGetList(Connection* conn, Selection sel, BList<Channel >& channels) = 0;
		BError dochannelGet(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError channelGet(Connection* conn, BUInt32 id, Channel& channel) = 0;
		BError dochannelUpdate(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError channelUpdate(Connection* conn, BInt32 append, Channel channel, BUInt32& id) = 0;
		BError dochannelDelete(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError channelDelete(Connection* conn, BUInt32 id) = 0;
		BError dosourceGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError sourceGetList(Connection* conn, BList<Source >& sources) = 0;
		BError dosourceUpdate(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError sourceUpdate(Connection* conn, BInt32 append, Source source, BUInt32& id) = 0;
		BError dosourceDelete(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError sourceDelete(Connection* conn, BUInt32 id) = 0;
		BError dosourcePriorityGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError sourcePriorityGetList(Connection* conn, BList<SourcePriority >& sourcePrioritys) = 0;
		BError dosourcePriorityUpdate(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError sourcePriorityUpdate(Connection* conn, BInt32 append, SourcePriority sourcePriority, BUInt32& id) = 0;
		BError dosourcePriorityDelete(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError sourcePriorityDelete(Connection* conn, BUInt32 id) = 0;
		BError dochannelInstrumentGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError channelInstrumentGetList(Connection* conn, Selection sel, BList<ChannelInstrument >& channelInstruments) = 0;
		BError dochannelInstrumentUpdate(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError channelInstrumentUpdate(Connection* conn, BInt32 append, ChannelInstrument channelInstrument, BUInt32& id) = 0;
		BError dochannelInstrumentDelete(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError channelInstrumentDelete(Connection* conn, BUInt32 id) = 0;
		BError dodigitiserGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError digitiserGetList(Connection* conn, Selection sel, BList<Digitiser >& digitisers) = 0;
		BError dodigitiserGet(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError digitiserGet(Connection* conn, BUInt32 id, Digitiser& digitiser) = 0;
		BError dodigitiserUpdate(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError digitiserUpdate(Connection* conn, BInt32 append, Digitiser digitiser, BUInt32& id) = 0;
		BError dodigitiserDelete(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError digitiserDelete(Connection* conn, BUInt32 id) = 0;
		BError dosensorGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError sensorGetList(Connection* conn, Selection sel, BList<Sensor >& sensors) = 0;
		BError dosensorGet(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError sensorGet(Connection* conn, BUInt32 id, Sensor& sensor) = 0;
		BError dosensorUpdate(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError sensorUpdate(Connection* conn, BInt32 append, Sensor sensor, BUInt32& id) = 0;
		BError dosensorDelete(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError sensorDelete(Connection* conn, BUInt32 id) = 0;
		BError docalibrationGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError calibrationGetList(Connection* conn, Selection sel, BList<Calibration >& calibrations) = 0;
		BError docalibrationUpdate(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError calibrationUpdate(Connection* conn, BInt32 append, Calibration calibration, BUInt32& id) = 0;
		BError docalibrationDelete(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError calibrationDelete(Connection* conn, BUInt32 id) = 0;
		BError doresponseGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError responseGetList(Connection* conn, Selection sel, BList<Response >& responses) = 0;
		BError doresponseUpdate(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError responseUpdate(Connection* conn, BInt32 append, Response response, BUInt32& id) = 0;
		BError doresponseDelete(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError responseDelete(Connection* conn, BUInt32 id) = 0;
		BError dodataFileGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataFileGetList(Connection* conn, Selection sel, BList<DataFileInfo >& dataFile) = 0;
		BError dodataFileUpdate(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataFileUpdate(Connection* conn, BInt32 append, DataFileInfo dataFile, BUInt32& id) = 0;
		BError dodataFileDelete(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataFileDelete(Connection* conn, BUInt32 id) = 0;
		BError dodataChannelGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataChannelGetList(Connection* conn, Selection sel, BList<DataChannel >& dataChannel) = 0;
		BError dodataChannelUpdate(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataChannelUpdate(Connection* conn, BInt32 append, DataChannel dataChannel, BUInt32& id) = 0;
		BError dodataChannelDelete(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataChannelDelete(Connection* conn, BUInt32 id) = 0;
		BError dodataSearch(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataSearch(Connection* conn, Selection selection, DataInfo& dataInfo) = 0;
		BError dodataGetChannelInfo(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataGetChannelInfo(Connection* conn, DataInfo dataInfo, ChannelInfos& channelInfos) = 0;
		BError dodataOpen(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataOpen(Connection* conn, DataInfo dataInfo, BString mode, BString format, BUInt32 flags, DataHandle& dataHandle) = 0;
		BError dodataGetInfo(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataGetInfo(Connection* conn, DataHandle dataHandle, BUInt32 infoExtra, DataInfo& dataInfo) = 0;
		BError dodataGetNotes(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataGetNotes(Connection* conn, DataHandle dataHandle, BList<Note >& notes) = 0;
		BError dodataGetWarnings(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataGetWarnings(Connection* conn, DataHandle dataHandle, BList<BString >& warnings) = 0;
		BError dodataGetBlock(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataGetBlock(Connection* conn, DataHandle dataHandle, BUInt32 channel, BUInt32 segment, BUInt32 blockNumber, DataBlock& data) = 0;
		BError dodataSeekBlock(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataSeekBlock(Connection* conn, DataHandle dataHandle, BUInt32 channel, BUInt32 segment, BTimeStamp time, BUInt32& blockNumber) = 0;
		BError dodataSetInfo(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataSetInfo(Connection* conn, DataHandle dataHandle, DataInfo dataInfo) = 0;
		BError dodataPutBlock(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataPutBlock(Connection* conn, DataHandle dataHandle, DataBlock data) = 0;
		BError dodataClose(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataClose(Connection* conn, DataHandle dataHandle, BError error, BInt32 del) = 0;
		BError dodataFormattedRead(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataFormattedRead(Connection* conn, DataHandle dataHandle, BUInt32 number, BArray<BUInt8 >& data) = 0;
		BError dodataFormattedGetLength(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataFormattedGetLength(Connection* conn, DataHandle dataHandle, BUInt64& length) = 0;
		BError dochangeGroupStart(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError changeGroupStart(Connection* conn, ChangeGroup changeGroup) = 0;
		BError dochangeGroupEnd(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError changeGroupEnd(Connection* conn) = 0;
		BError dochangeGroupGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError changeGroupGetList(Connection* conn, ListRange range, BList<ChangeGroup >& changeGroups) = 0;
		BError dochangeGroupDelete(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError changeGroupDelete(Connection* conn, BTimeStamp beforeDate, BString type, BInt32 empty) = 0;
		BError dochangeGetListNumber(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError changeGetListNumber(Connection* conn, BUInt32 id, BUInt32& number) = 0;
		BError dochangeGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError changeGetList(Connection* conn, BUInt32 id, ListRange range, BList<Change >& changes) = 0;
		BError dochangeDelete(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError changeDelete(Connection* conn, BTimeStamp beforeDate, BString type) = 0;
		BError donoteGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError noteGetList(Connection* conn, Selection sel, BList<Note >& notes) = 0;
		BError donoteUpdate(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError noteUpdate(Connection* conn, BInt32 append, Note note, BUInt32& id) = 0;
		BError donoteDelete(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError noteDelete(Connection* conn, BUInt32 id) = 0;
		BError donoteWriteDocument(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError noteWriteDocument(Connection* conn, BUInt32 id, BString format, BArray<BUInt8 > data) = 0;
		BError donoteReadDocument(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError noteReadDocument(Connection* conn, BUInt32 id, BString& format, BArray<BUInt8 >& data) = 0;
		BError dologGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError logGetList(Connection* conn, LogSelect sel, BList<Log >& logs) = 0;
		BError dologUpdate(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError logUpdate(Connection* conn, BInt32 append, Log log, BUInt32& id) = 0;
		BError dologDelete(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError logDelete(Connection* conn, BUInt32 id) = 0;
		BError dologAppend(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError logAppend(Connection* conn, BString type, BUInt32 priority, BString subSystem, BString title, BString description) = 0;
		BError dostatisticsGet(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError statisticsGet(Connection* conn, BDict<BString >& info) = 0;
		BError dodataFormatGetList(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError dataFormatGetList(Connection* conn, BList<DataFormat >& formats) = 0;
		BError dotransactionStart(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError transactionStart(Connection* conn) = 0;
		BError dotransactionEnd(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError transactionEnd(Connection* conn, BInt32 abort) = 0;
		BError domodeSet(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError modeSet(Connection* conn, Mode mode, Mode& previousMode) = 0;
		BError domodeSnapshotPause(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError modeSnapshotPause(Connection* conn, BInt32 on) = 0;
		BError doclean(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError clean(Connection* conn, CleanOptions cleanOptions) = 0;
		BError dodatabaseBackup(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError databaseBackup(Connection* conn, BString& ref) = 0;
		BError dodatabaseRestore(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError databaseRestore(Connection* conn, BString ref, BString type) = 0;
		BError dosqlQuery(BoapServerConnection* conn, BoapPacket& rx, BoapPacket& tx);
		virtual BError sqlQuery(Connection* conn, BString query, BList<BDict<BString > >& result) = 0;
	};
}
#endif
