/*******************************************************************************
 *	BdsSeedTypes.h	Created by createTypes
 *******************************************************************************
 */
#include <BdsSeedType.h>

class BdsSeedType10 : public BdsSeedType {
public:
	BError		setData(void* data);
	BString		getStringOutput();
	void		print();
public:
	int		bType;
	int		bLen;
	double		version;
	int		recordLength;
	BString		beginTime;
	BString		endTime;
	BString		volTime;
	BString		organization;
	BString		label;
};

class BdsSeedStation {
public:
	BString		stationId;
	int		seqNum;
};

class BdsSeedType11 : public BdsSeedType {
public:
	BError		setData(void* data);
	BString		getStringOutput();
	void		print();
public:
	int		bType;
	int		bLen;
	BArray<BdsSeedStation>		stations;
};

class BdsSeedSpan {
public:
	BString		startTime;
	BString		endTime;
	int		blockNum;
};

class BdsSeedType12 : public BdsSeedType {
public:
	BError		setData(void* data);
	BString		getStringOutput();
	void		print();
public:
	int		bType;
	int		bLen;
	BArray<BdsSeedSpan>		spans;
};

class BdsSeedKey {
public:
	BString		decoderKeys;
};

class BdsSeedType30 : public BdsSeedType {
public:
	BError		setData(void* data);
	BString		getStringOutput();
	void		print();
public:
	int		bType;
	int		bLen;
	BString		name;
	int		dataFormat;
	int		dataFamily;
	BArray<BdsSeedKey>		keys;
};

class BdsSeedType33 : public BdsSeedType {
public:
	BError		setData(void* data);
	BString		getStringOutput();
	void		print();
public:
	int		bType;
	int		bLen;
	int		code;
	BString		value;
};

class BdsSeedType34 : public BdsSeedType {
public:
	BError		setData(void* data);
	BString		getStringOutput();
	void		print();
public:
	int		bType;
	int		bLen;
	int		code;
	BString		name;
	BString		description;
};

class BdsSeedFactor {
public:
	double		coefficient;
};

class BdsSeedType41 : public BdsSeedType {
public:
	BError		setData(void* data);
	BString		getStringOutput();
	void		print();
public:
	int		bType;
	int		bLen;
	int		responseKey;
	BString		responseName;
	BString		symmetryCode;
	int		signalInUnits;
	int		signalOutUnits;
	BArray<BdsSeedFactor>		factors;
};

class BdsSeedZero1 {
public:
	double		zreal;
	double		zimag;
	double		zrealError;
	double		zimagError;
};

class BdsSeedPole1 {
public:
	double		preal;
	double		pimag;
	double		prealError;
	double		pimagError;
};

class BdsSeedType43 : public BdsSeedType {
public:
	BError		setData(void* data);
	BString		getStringOutput();
	void		print();
public:
	int		bType;
	int		bLen;
	int		responseKey;
	BString		responseName;
	BString		responseType;
	int		signalInUnits;
	int		signalOutUnits;
	double		normFactor;
	double		normFreq;
	BArray<BdsSeedZero1>		zero1s;
	BArray<BdsSeedPole1>		pole1s;
};

class BdsSeedType47 : public BdsSeedType {
public:
	BError		setData(void* data);
	BString		getStringOutput();
	void		print();
public:
	int		bType;
	int		bLen;
	int		responseKey;
	BString		responseName;
	double		inputRate;
	int		decimationFactor;
	int		decimationOffset;
	double		delay;
	double		correction;
};

class BdsSeedCalibration1 {
public:
	double		calSensitivity;
	double		calFreq;
	BString		calTime;
};

class BdsSeedType48 : public BdsSeedType {
public:
	BError		setData(void* data);
	BString		getStringOutput();
	void		print();
public:
	int		bType;
	int		bLen;
	int		responseKey;
	BString		responseName;
	double		gain;
	double		freq;
	BArray<BdsSeedCalibration1>		calibration1s;
};

class BdsSeedType50 : public BdsSeedType {
public:
	BError		setData(void* data);
	BString		getStringOutput();
	void		print();
public:
	int		bType;
	int		bLen;
	BString		stationCall;
	double		latitude;
	double		longitude;
	double		elevation;
	int		numChannels;
	int		numComments;
	BString		name;
	int		networkId;
	int		wordOrder32;
	int		wordOrder16;
	BString		startData;
	BString		endDate;
	BString		updateFlag;
	BString		networkCode;
};

class BdsSeedType52 : public BdsSeedType {
public:
	BError		setData(void* data);
	BString		getStringOutput();
	void		print();
public:
	int		bType;
	int		bLen;
	BString		location;
	BString		channel;
	int		subChannel;
	int		instrument;
	BString		comment;
	int		responseUnits;
	int		calibrationUnits;
	double		latitude;
	double		longitude;
	double		elevation;
	double		depth;
	double		azimuth;
	double		dip;
	int		dataFormat;
	int		dataLen;
	double		sampleRate;
	double		clockDrift;
	int		numComments;
	BString		channelFlags;
	BString		startTime;
	BString		endDate;
	BString		updateFlag;
};

class BdsSeedZero {
public:
	double		zreal;
	double		zimag;
	double		zrealError;
	double		zimagError;
};

class BdsSeedPole {
public:
	double		preal;
	double		pimag;
	double		prealError;
	double		pimagError;
};

class BdsSeedType53 : public BdsSeedType {
public:
	BError		setData(void* data);
	BString		getStringOutput();
	void		print();
public:
	int		bType;
	int		bLen;
	BString		responseType;
	int		stageNumber;
	int		signalInUnits;
	int		signalOutUnits;
	double		normFactor;
	double		normFreq;
	BArray<BdsSeedZero>		zeros;
	BArray<BdsSeedPole>		poles;
};

class BdsSeedNumerator {
public:
	double		ncoefficient;
	double		nerror;
};

class BdsSeedDenominator {
public:
	double		dcoefficient;
	double		derror;
};

class BdsSeedType54 : public BdsSeedType {
public:
	BError		setData(void* data);
	BString		getStringOutput();
	void		print();
public:
	int		bType;
	int		bLen;
	BString		responseType;
	int		stageNumber;
	int		signalInUnits;
	int		signalOutUnits;
	BArray<BdsSeedNumerator>		numerators;
	BArray<BdsSeedDenominator>		denominators;
};

class BdsSeedFap {
public:
	double		frequency;
	double		amplitude;
	double		amplitudeError;
	double		phase;
	double		phaseError;
};

class BdsSeedType55 : public BdsSeedType {
public:
	BError		setData(void* data);
	BString		getStringOutput();
	void		print();
public:
	int		bType;
	int		bLen;
	int		stageNumber;
	int		signalInUnits;
	int		signalOutUnits;
	BArray<BdsSeedFap>		faps;
};

class BdsSeedCalibration {
public:
	double		gain;
	double		freq;
	BString		time;
};

class BdsSeedType58 : public BdsSeedType {
public:
	BError		setData(void* data);
	BString		getStringOutput();
	void		print();
public:
	int		bType;
	int		bLen;
	int		stageNumber;
	double		gain;
	double		freq;
	BArray<BdsSeedCalibration>		calibrations;
};

class BdsSeedStage {
public:
	int		id;
	int		keyNum;
	int		key;
};

class BdsSeedType60 : public BdsSeedType {
public:
	BError		setData(void* data);
	BString		getStringOutput();
	void		print();
public:
	int		bType;
	int		bLen;
	BArray<BdsSeedStage>		stages;
};

class BdsSeedType70 : public BdsSeedType {
public:
	BError		setData(void* data);
	BString		getStringOutput();
	void		print();
public:
	int		bType;
	int		bLen;
	BString		flag;
	BString		startTime;
	BString		endTime;
};

class BdsSeedAccelerator {
public:
	BString		time;
	int		block;
	int		blockSub;
};

class BdsSeedType74 : public BdsSeedType {
public:
	BError		setData(void* data);
	BString		getStringOutput();
	void		print();
public:
	int		bType;
	int		bLen;
	BString		station;
	BString		location;
	BString		channel;
	BString		startTime;
	int		startBlock;
	int		startBlockSub;
	BString		endTime;
	int		endBlock;
	int		endBlockSub;
	BArray<BdsSeedAccelerator>		accelerators;
	BString		network;
};

