/* Copyright 1994 Science Applications International Corporation
 *
 * This software may not be used, copied, modified, or distributed without
 * the express written permission of Science Applications International
 * Corporation (SAIC).  SAIC makes no warranty of any kind with regard
 * to this software, including, but not limited to, the implied warranties
 * of fitness for a particular purpose.
 */

/* #pragma ident "@(#)canada_compress.h	1.1	05/18/00	SAIC" */

#include <arpa/inet.h>

#ifndef CANADACOMP_H
#define CANADACOMP_H

#define CANCOMP_ERR	-1	/* unrecoverable error (malloc fails) */
#define CANCOMP_SUCCESS	 0	/* success */
#define CANCOMP_NOT_20   1	/* number of samples not divisible by 20 */
#define CANCOMP_CORRUPT	 2	/* corrupted call */
#define CANCOMP_EXCEED	 3	/* number of bytes available in compressed
				   data exceeded during decompression */

int canada_uncompress(unsigned char *b, uint32_t *y, int *n, int m,
			uint32_t *v0);
int canada_compress(unsigned char *b, unsigned long *y, int *n, int m,
                    unsigned long *v0);

#endif /* CANADACOMP_H */
