/*******************************************************************************
 *	BMainWindow.h	BEAM AppMainWindow
 *				T.Barnaby,	BEAM Ltd,	2009-07-29
 *******************************************************************************
 */
#ifndef	BMainWindow_H
#define BMainWindow_H	1

#include <qmainwindow.h>
#include <BList.h>

class QAction;
class QMenu;
class QPlainTextEdit;

class BMainWindow: public QMainWindow {
	Q_OBJECT
public:
				BMainWindow();
	virtual			~BMainWindow();

	virtual void		init(QString title);
	virtual void		initActions();
	virtual void		initMenubar();
	virtual void		initToolbar();
	virtual void		initMain();
	virtual void		initStatus();
	
	// Helper functions
	virtual QAction*	newAction(QString name, QString accelKey, QString tip, QString memberFunc);
	virtual QAction*	newAction(QString name, QString accelKey, QString tip, QWidget* w, QString memberFunc);

public slots:
	virtual void		quit();

private:
	BList<QAction*>		oactions;
	BList<QMenu*>		omenus;
    	QToolBar*		otoolbar;
};

#endif
