/*******************************************************************************
 *	BTypes.h	Basic Types
 *			T.Barnaby,	BEAM Ltd,	1/4/05
 *******************************************************************************
 */
#ifndef BTYPES_H
#define BTYPES_H	1

#include <stdint.h>
#include <sys/types.h>
#include <vector>

typedef int8_t			BInt8;
typedef uint8_t			BUInt8;
typedef int16_t			BInt16;
typedef uint16_t		BUInt16;
typedef int32_t			BInt32;
typedef uint32_t		BUInt32;
typedef int64_t			BInt64;
typedef uint64_t		BUInt64;
typedef float			BFloat32;
typedef double			BFloat64;

typedef float			BFloat;
typedef double			BDouble;
typedef size_t			BSize;
typedef std::vector<float>	BArrayFloat;
typedef std::vector<double>	BArrayDouble;

// Generic
typedef BInt32			BInt;
typedef BUInt32			BUInt;

#ifdef ZAP
// For BOAP
typedef int8_t			Int8;
typedef uint8_t			UInt8;
typedef int16_t			Int16;
typedef uint16_t		UInt16;
typedef int32_t			Int32;
typedef uint32_t		UInt32;
typedef int64_t			Int64;
typedef uint64_t		UInt64;
typedef float			Float32;
typedef double			Float64;
typedef double			Double;
#endif

// Byte swap routines
inline void byteSwap8(void* d, void* s){
	char*	dp = (char*)d;
	char*	sp = (char*)s;

	*dp = *sp;
}
inline void byteSwap16(void* d, void* s){
	char*	dp = (char*)d;
	char*	sp = (char*)s;

	dp[1] = sp[0];
	dp[0] = sp[1];
}
inline void byteSwap32(void* d, void* s){
	char*	dp = (char*)d;
	char*	sp = (char*)s;

	dp[3] = sp[0];
	dp[2] = sp[1];
	dp[1] = sp[2];
	dp[0] = sp[3];
}
inline void byteSwap64(void* d, void* s){
	char*	dp = (char*)d;
	char*	sp = (char*)s;

	dp[7] = sp[0];
	dp[6] = sp[1];
	dp[5] = sp[2];
	dp[4] = sp[3];
	dp[3] = sp[4];
	dp[2] = sp[5];
	dp[1] = sp[6];
	dp[0] = sp[7];
}

#endif
